package cn.com.qmth.stmms.admin.exam;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import net.sf.json.JSONArray;
import net.sf.json.JsonConfig;

import org.apache.commons.lang.StringEscapeUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import cn.com.qmth.stmms.biz.exam.model.ExamSubject;
import cn.com.qmth.stmms.biz.exam.service.ExamSubjectService;
import cn.com.qmth.stmms.biz.mark.model.PictureConfigItem;
import cn.com.qmth.stmms.common.auth.annotation.RoleRequire;
import cn.com.qmth.stmms.common.enums.Role;

@Controller
@RequestMapping("/admin/exam/subject")
public class SubjectController extends BaseExamController {

    @Autowired
    private ExamSubjectService subjectService;

    @RequestMapping("/edit")
    @RoleRequire(Role.SCHOOL_ADMIN)
    public String edit(HttpServletRequest request, @RequestParam String code, Model model) {
        ExamSubject subject = subjectService.find(getSessionExamId(request), code);
        model.addAttribute("subject", subject);
        model.addAttribute("pictureConfig", buildPictureConfig(subject.getSheetConfig()));
        return "modules/exam/subjectEdit";
    }

    @SuppressWarnings("unchecked")
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @RoleRequire(Role.SCHOOL_ADMIN)
    public String save(HttpServletRequest request, ExamSubject subject, Model model,@RequestParam String picList) {
        ExamSubject previous = subjectService.find(getSessionExamId(request), subject.getCode());
        if (previous != null && StringUtils.isNotBlank(picList)) {
            String sheetConfig = StringEscapeUtils.unescapeHtml(picList);
            JSONArray array = JSONArray.fromObject(sheetConfig);
            List<PictureConfigItem> list = JSONArray.toList(array, new PictureConfigItem(), new JsonConfig());
            previous.setSheetConfig(list==null?null:StringUtils.join(list, PictureConfigItem.DB_ITEM_JOINER));
            subjectService.save(previous);
        }
        model.addAttribute("subject", previous);
        model.addAttribute("pictureConfig", buildPictureConfig(subject.getSheetConfig()));
        model.addAttribute("message", "修改成功");
        return "modules/exam/subjectEdit";
    }
    
}
